


'''
https://fdc.nal.usda.gov/fdc-app.html#/food-details/1882785/nutrients
'''



'''
	python3 status.py "FOOD/USDA/struct_2/_status/STATUS_walnuts_1882785.py"
'''

import json

import cyte.FOOD.USDA.EXAMPLES as USDA_EXAMPLES

import cyte.FOOD.USDA.struct_2 as USDA_struct_2
import cyte.FOOD.USDA.struct_2.ingredients.quantified_grove.printer as quantified_grove_printer

import cyte._ensure.eq as equality

def CHECK_1 ():
	food_struct_2 = USDA_struct_2.CALC (
		USDA_EXAMPLES.RETRIEVE ("BRANDED/walnuts_1882785.json")
	)
	
	print (json.dumps (food_struct_2, indent = 4))

	#import pyjsonviewer
	#pyjsonviewer.view_data (json_data = food_struct_2)
	
	ingredients_quantified_grove = food_struct_2 ["ingredients"]["quantified grove"]
	quantified_grove_printer.start (ingredients_quantified_grove)
	
	#
	#	equality checks
	#
	
	equality.check (food_struct_2 ["defined"]["serving size"]["kind"], "mass")
	equality.check (food_struct_2 ["defined"]["serving size"]["amount"], "28")
	equality.check (food_struct_2 ["defined"]["serving size"]["unit"], "g")
	equality.check (food_struct_2 ["defined"]["servings per package, fraction string"], "227/14")
	
	
	equality.check (food_struct_2 ["mass"]["per package, in grams"], "454")
	
	equality.check (
		len (food_struct_2 ["ingredients"]["quantified list"]),
		16
	)
	equality.check (
		len (food_struct_2 ["ingredients"]["quantified grove"]),
		10
	)
	
	
	
CHECKS = {
	"walnuts 1882785": CHECK_1
}


